package quoggles.constants;

import java.awt.Color;

/**
 * Provides constants that the various boxes can use 
 * (for parameter values etc).
 */
public interface IBoxConstants {

    public final String DEGREE = "degree";
    
    public final String INDEGREE = "in-degree";
    
    public final String OUTDEGREE = "out-degree";
    
    public final String UNION = "union";
    
    public final String INTERSECT = "intersect";
    
    public final String LISTMINUS = "list minus";
    
    public final String COMP_TYPE = "compType";
    
    public final String ATTR_TYPE = "attrType";
    
    public final String ATTR_PATH = "attrPath";
    
    public final String ATTR_VALUE = "attrValue";
    
    public final String REL_TYPE = "relType";
    
    public final String EQUAL_CMP = "=";
    
    public final String NOTEQUAL_CMP = "!=";
    
    public final String LT_CMP = "<";
    
    public final String GT_CMP = ">";
    
    public final String LTE_CMP = "<=";
    
    public final String GTE_CMP = ">=";
    
    public final String AND_STR = "AND";
    
    public final String OR_STR = "OR";
    
    public final String XOR_STR = "XOR";
    
    public final String NOR_STR = "NOR";
    
    public final String NODE_CLASSNAME =
        "org.graffiti.graph.Node";
    
    public final String EDGE_CLASSNAME =
        "org.graffiti.graph.Edge";
    
    public final String GRAPHELEMENT_CLASSNAME =
        "org.graffiti.graph.GraphElement";
    
    public final String ATTRIBUTABLE_CLASSNAME =
        "org.graffiti.attributes.Attributable";
    
    public final String ATTRIBUTE_CLASSNAME =
        "org.graffiti.attributes.Attribute";
    
    public final String STRING_CLASSNAME =
        "java.lang.String";
    
    public final String NUMBER_CLASSNAME =
        "java.lang.Number";
    
    public final String COLLECTION_CLASSNAME =
        "java.util.Collection";
    
    public final String[] ROWNUMBERS = new String[]
        { "col: 0", "col: 1", "col: 2", "col: 3", "col: 4", "col: 5", 
          "col: 6", "col: 7", "col: 8", "col: 9",
          "col: 10", "col: 11", "col: 12", "col: 13", "col: 14", "col: 15",
          "col: 16", "col: 17", "col: 18", "col: 19" };
    
    public final String[] ASC_DESC = new String[]
        { "asc.", "desc." };
    
    public final String INTEGER_PAR = 
        "org.graffiti.plugin.parameter.IntegerParameter";

    public final String DOUBLE_PAR = 
        "org.graffiti.plugin.parameter.DoubleParameter";

    public final String BOOLEAN_PAR = 
        "org.graffiti.plugin.parameter.BooleanParameter";

    public final String NODE_PAR = 
        "org.graffiti.plugin.parameter.NodeParameter";

    public final String OBJECT_PAR = 
        "org.graffiti.plugin.parameter.ObjectParameter";

    public final String SELECTION_PAR = 
        "org.graffiti.plugin.parameter.SelectionParameter";

    public final String EDGE_PAR = 
        "org.graffiti.plugin.parameter.EdgeParameter";

    public final String STRING_PAR = 
        "org.graffiti.plugin.parameter.StringParameter";

    public final String[] PARTYPES = new String[]
        { INTEGER_PAR, DOUBLE_PAR, BOOLEAN_PAR, NODE_PAR,
          OBJECT_PAR, SELECTION_PAR, EDGE_PAR, STRING_PAR };
    
    public final String EMPTY = "EMPTY";
    
    public final String[] TYPES = new String[]
        { ITypeConstants.INTEGER_STR, ITypeConstants.DOUBLE_STR,
          ITypeConstants.BOOLEAN_STR, ITypeConstants.STRING_STR,
          EMPTY, ITypeConstants.COLLECTION_STR };
    
    public final String FUN_PLUS = "+";
    
    public final String FUN_MINUS = "-";
    
    public final String FUN_TIMES = "*";
    
    public final String FUN_DIVIDE = "/";
    
    public final String FUN_SUM = "sum";
    
    public final String FUN_AVG = "avg";
    
    public final String FUN_MAX = "max";
    
    public final String FUN_MIN = "min";
    
    public final String FUN_COUNT = "count";
    
    public final String[] FUNS = new String[]{
        FUN_SUM, FUN_AVG, FUN_MAX, FUN_MIN, FUN_COUNT,
        "--------", FUN_PLUS, FUN_MINUS, FUN_TIMES, FUN_DIVIDE };

    public final String FLATTEN = "flatten";
    
    public final String REVERSE = "reverse";
    
    public final String UNPACK = "unpack";
    
    public final String MAKEDISTINCT = "make distinct";
    
    public final String LISTIFY = "listify";
    
    public final String DELISTIFY = "de-listify";
    
    public final String REMOVEEMPTY = "remove empty";
    
    public final String[] LISTOPERS = new String[]{
        FLATTEN, REVERSE, MAKEDISTINCT, LISTIFY, 
        DELISTIFY, UNPACK, REMOVEEMPTY };

    public final int GETNODES = 0;
    
    public final int GETEDGES = 1;
    
    public final int GETELEMENTS = 2;
    
    public final String GRAPH_INPUT = "graph";

    public final String GRAPH_INPUT_DISPLAY = 
        "<html>graph<p>elements<p>from<p>graph</html>";
    
    public final String SELECTION_INPUT = "selection";

    public final String SELECTION_INPUT_DISPLAY = 
        "<html>graph<p>elements<p>from<p>selection</html>";
    
    public final String BOX_ATTR_ID = "box";
    
    public final String BOX_CLASSNAME_ATTR_ID = "box";

    public final String BOX_PARAM_ATTR_ID = "box";
    
    public final String NEIGHBORS = "neighbors";

    public final String INC_EDGES = "inc. edges";

    public final String OUT_EDGES = "out-edges";

    public final String IN_EDGES = "in-edges";

    public final String INC_NODES = "inc. nodes";

    public final String SOURCE_NODE = "source node";

    public final String TARGET_NODE = "target node";

    public final int MAX_BOX_WIDTH = 220;
    
    public final int DEFAULT_BOX_WIDTH = 165;
    
    public final int DEFAULT_BOX_HEIGHT = 110;
    
    public final int DEFAULT_INPUTBOX_WIDTH = 70;
    
    public final int DEFAULT_INPUTBOX_HEIGHT = 30;
    
    public final int DEFAULT_OUTPUTBOX_IO_HEIGHT = 60;

    public final int DEFAULT_ICON_WIDTH = 60;
    
    public final int DEFAULT_ICON_HEIGHT = 30;

    public final int DEFAULT_CONNECTOR_WIDTH = 100;
    
    public final int DEFAULT_CONNECTOR_HEIGHT = 220;
    
    public final int ONEONE_CONNECTOR_WIDTH = 200;
    
    public final int ONEONE_CONNECTOR_HEIGHT = 2;
    
    public final Color BOX_BACKGROUND = Color.LIGHT_GRAY; //new Color(200, 200, 230);  
    
    public final Color PARAM_BACKGROUND = Color.WHITE;
    
    public final Color ICON_BACKGROUND = new Color(200, 200, 230); //Color.WHITE;
    
    public final Color ICONPANEL_BACKGROUND = Color.WHITE; // new Color(245, 222, 222);
    
    public final Color INPUTPANEL_BACKGROUND = Color.WHITE; // new Color(210, 245, 210);
    
    public final Color MAINPANEL_BACKGROUND = new Color(230, 230, 230); //Color.LIGHT_GRAY; // Color.WHITE; 

    public final Color OK_SIGN_COLOR = Color.GREEN;
    
    public final Color BAD_SIGN_COLOR = Color.RED;

    public final Color NEARLY_OK_SIGN_COLOR = Color.YELLOW;
    
    public final Color CLASS_LABEL_COLOR = Color.BLUE;
    
    public final Color IO_FILL_COLOR = Color.LIGHT_GRAY;
    
    public final Color IO_BORDER_COLOR = Color.BLACK;
    
    public final int IO_BORDER_WIDTH = 1;
    
    public final int IO_THICKNESS = 8;
    
    public final int IO_LENGTH = 20;
    
    public final int IO_LONG_LENGTH = 200;
    
    public final int SMALL_IO_LENGTH = 10;
    
    public final int SMALL_IO_WIDTH = 2;
    
    public final int GRAPH_INPUT_Y = 275;
    
    public final int SELECTION_INPUT_Y = 365;
    
}
