package quoggles.constants;

import java.util.Map;

/**
 * Provides constants for possible input / output types.
 */
public interface ITypeConstants {
    
    public final String SAME_STR = "==";

    public final String EQUALS_STR = "via equals";

    public final String INTEGER_STR = "integer";
    
    public final String FLOATING_STR = "floating";
    
    public final String DOUBLE_STR = "double";
    
    public final String STRING_STR = "string";
    
    public final String BOOLEAN_STR = "boolean";
    
    public final String NUMBER_STR = "number";

    public final String LABEL_STR = "label";

    public final String OBJECT_STR = "object";

    public final String COLLECTION_STR = "collection";

    public final int NONE = -1;

    public final int GENERAL = 0;

    /** @deprecated */
    public final int GRAPH = 1;

    public final int NODE = 2;

    public final int EDGE = 4;

    public final int GRAPH_ELEMENT = 6;
    
    public final int ATTRIBUTABLE = 7;

    public final int NODES = 8;

    public final int EDGES = 16;

    public final int GRAPH_ELEMENTS = 24;
    
    /** @deprecated */
    public final int SELECTION = 32;
    
    public final int NUMBER = 64;
    
    public final int BOOLEAN = 128;
    
    /** @deprecated */
    public final int GRAPHS = 256;

    public final int ATTRIBUTABLES = 280;
    
    public final int ONEOBJECT = 512;
    
    public final int COLLECTION = 1024;
    
    public final int COLOF_NODESET = 2048;
    
    public final int COLOF_EDGESET = 4096;

    public final int COLOF_NUMBER = 9092;
    
    public final int PARAMETER = 18184;

    public final int INTEGER_PAR = 18185;

    public final int DOUBLE_PAR = 18186;

    public final int EDGE_PAR = 18187;

    public final int NODE_PAR = 18188;

    public final int STRING_PAR = 18189;

    public final int SELECTION_PAR = 18190;

    public final int BOOLEAN_PAR = 18191;

    public final int OBJECT_PAR = 18192;

    public final int COLOF_COLS = 36400;

    public final Map intStringMap = TypeStringConstants.getMap();

}
