package quoggles.constants;


/**
 *
 */
public interface QConstants {

    /**
     * Indicates that a table cell is empty. This is different from a cell that
     * contains the <code>null</code> value. 
     */
    public static final Object EMPTY = new Object();

    /**
     * The relative path and filename  of the box descriptions file
     */
    public static final String BOXES_DESCRIPTION_FILE = 
        "../Quoggles/quoggles/boxes.xml";
        
    /**
     * Maximum number of rows (which restricts the maximum number of output
     * boxes).
     */
    public static final int MAX_ROWS = 20;
    
    /** Attributes that are saved as XML are prefixed */
    public static final String XML_PREFIX = "_XML_";

    /** Attribute ID; input index of an edge */
    public static final String INPUT_INDEX_ID = "_InputIndex_";

    /** Attribute ID; output index of an edge */
    public static final String OUTPUT_INDEX_ID = "_OutputIndex_";

    /** Attribute ID of BoxAttribute that saves box at a node */
    public static final String OUTPUT_BOX_ID = "_OutputBox_";

    /** Node coordinates are shifted to the right of input boxes */
    public static final int shiftX = 75;
    
    /**
     * Id of attribute specifying the ordered position of an input within
     * the marked graph.
     */ 
    public static final String MARKED_INPUT_NRS_ID = "_InputNrs_";
    
    /**
     * Id of attribute specifying the ordered position of an input within
     * the marked graph.
     */ 
    public static final String MARKED_OUTPUT_NRS_ID = "_OutputNrs_";
    
    /** Used as max distance between two connected boxes */
    public final int EPSILON = 1;
    
}
